--- old/usr/src/cmd/sendmail/src/srvrsmtp.c	Sat Feb  6 15:36:48 2016
+++ new/usr/src/cmd/sendmail/src/srvrsmtp.c	Sat Feb  6 15:36:48 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2008 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2010, 2012, 2013 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -17,7 +17,7 @@
 # include <libmilter/mfdef.h>
 #endif /* MILTER */
 
-SM_RCSID("@(#)$Id: srvrsmtp.c,v 8.989 2009/12/18 17:08:01 ca Exp $")
+SM_RCSID("@(#)$Id: srvrsmtp.c,v 8.1016 2013-11-22 20:51:56 ca Exp $")
 
 #include <sm/time.h>
 #include <sm/fdset.h>
@@ -30,6 +30,7 @@
 static int saslmechs __P((sasl_conn_t *, char **));
 #endif /* SASL */
 #if STARTTLS
+#  include <openssl/err.h>
 # include <sysexits.h>
 
 static SSL_CTX	*srv_ctx = NULL;	/* TLS server context */
@@ -875,10 +876,8 @@
 
 		/* XXX should these be options settable via .cf ? */
 		/* ssp.min_ssf = 0; is default due to memset() */
-		{
-			ssp.max_ssf = MaxSLBits;
-			ssp.maxbufsize = MAXOUTLEN;
-		}
+		ssp.max_ssf = MaxSLBits;
+		ssp.maxbufsize = MAXOUTLEN;
 		ssp.security_flags = SASLOpts & SASL_SEC_MASK;
 		sasl_ok = sasl_setprop(conn, SASL_SEC_PROPS, &ssp) == SASL_OK;
 
@@ -909,15 +908,6 @@
 #endif /* SASL */
 
 #if STARTTLS
-# if USE_OPENSSL_ENGINE
-	if (tls_ok_srv && bitset(SRV_OFFER_TLS, features) &&
-	    !SSL_set_engine(NULL))
-	{
-		sm_syslog(LOG_ERR, NOQID,
-			  "STARTTLS=server, SSL_set_engine=failed");
-		tls_ok_srv = false;
-	}
-# endif /* USE_OPENSSL_ENGINE */
 
 
 	set_tls_rd_tmo(TimeOuts.to_nextcommand);
@@ -1836,6 +1826,21 @@
 				break;
 			}
   starttls:
+# if USE_OPENSSL_ENGINE
+			if (!SSLEngineInitialized)
+			{
+				if (!SSL_set_engine(NULL))
+				{
+					sm_syslog(LOG_ERR, NOQID,
+						  "STARTTLS=server, SSL_set_engine=failed");
+					tls_ok_srv = false;
+					message("454 4.3.3 TLS not available right now");
+					break;
+				}
+				else
+					SSLEngineInitialized = true;
+			}
+# endif /* USE_OPENSSL_ENGINE */
 # if TLS_NO_RSA
 			/*
 			**  XXX do we need a temp key ?
@@ -1859,7 +1864,7 @@
 			{
 				message("454 4.3.3 TLS not available: error generating SSL handle");
 				if (LogLevel > 8)
-					tlslogerr("server");
+					tlslogerr(LOG_WARNING, "server");
 				goto tls_done;
 			}
 
@@ -1910,12 +1915,19 @@
 
 				if (LogLevel > 5)
 				{
+					unsigned long l;
+					const char *sr;
+
+					l = ERR_peek_error();
+					sr = ERR_reason_error_string(l);
 					sm_syslog(LOG_WARNING, NOQID,
-						  "STARTTLS=server, error: accept failed=%d, SSL_error=%d, errno=%d, retry=%d, relay=%.100s",
-						  r, ssl_err, errno, i,
+						  "STARTTLS=server, error: accept failed=%d, reason=%s, SSL_error=%d, errno=%d, retry=%d, relay=%.100s",
+						  r, sr == NULL ? "unknown"
+								: sr,
+						  ssl_err, errno, i,
 						  CurSmtpClient);
-					if (LogLevel > 8)
-						tlslogerr("server");
+					if (LogLevel > 9)
+						tlslogerr(LOG_WARNING, "server");
 				}
 				tls_ok_srv = false;
 				SSL_free(srv_ssl);
@@ -2260,8 +2272,7 @@
 				message("250-AUTH %s", mechlist);
 #endif /* SASL */
 #if STARTTLS
-			if (tls_ok_srv &&
-			    bitset(SRV_OFFER_TLS, features))
+			if (tls_ok_srv && bitset(SRV_OFFER_TLS, features))
 				message("250-STARTTLS");
 #endif /* STARTTLS */
 			if (DeliverByMin > 0)
@@ -2622,7 +2633,7 @@
 				goto rcpt_done;
 			}
 
-			if (e->e_sendmode != SM_DELIVER
+			if (!SM_IS_INTERACTIVE(e->e_sendmode)
 #if _FFR_DM_ONE
 			    && (NotFirstDelivery || SM_DM_ONE != e->e_sendmode)
 #endif /* _FFR_DM_ONE */
@@ -3478,7 +3489,7 @@
 	collect(InChannel, true, NULL, e, true);
 
 	/* redefine message size */
-	(void) sm_snprintf(buf, sizeof(buf), "%ld", e->e_msgsize);
+	(void) sm_snprintf(buf, sizeof(buf), "%ld", PRT_NONNEGL(e->e_msgsize));
 	macdefine(&e->e_macro, A_TEMP, macid("{msg_size}"), buf);
 
 	/* rscheck() will set Errors or EF_DISCARD if it trips */
@@ -3556,7 +3567,7 @@
 	}
 
 	/* Milter may have changed message size */
-	(void) sm_snprintf(buf, sizeof(buf), "%ld", e->e_msgsize);
+	(void) sm_snprintf(buf, sizeof(buf), "%ld", PRT_NONNEGL(e->e_msgsize));
 	macdefine(&e->e_macro, A_TEMP, macid("{msg_size}"), buf);
 
 	/* abort message filters that didn't get the body & log msg is OK */
@@ -3724,6 +3735,7 @@
 	_res.retrans = TimeOuts.res_retrans[RES_TO_FIRST];
 #endif /* NAMED_BIND */
 
+
 	for (ee = e; ee != NULL; ee = ee->e_sibling)
 	{
 		/* make sure we actually do delivery */
@@ -3767,18 +3779,18 @@
 	oldid = CurEnv->e_id;
 	CurEnv->e_id = id;
 
-	/* issue success message */
+		/* issue success message */
 #if _FFR_MSG_ACCEPT
-	if (MessageAccept != NULL && *MessageAccept != '\0')
-	{
-		char msg[MAXLINE];
+		if (MessageAccept != NULL && *MessageAccept != '\0')
+		{
+			char msg[MAXLINE];
 
-		expand(MessageAccept, msg, sizeof(msg), e);
-		message("250 2.0.0 %s", msg);
-	}
-	else
+			expand(MessageAccept, msg, sizeof(msg), e);
+			message("250 2.0.0 %s", msg);
+		}
+		else
 #endif /* _FFR_MSG_ACCEPT */
-	message("250 2.0.0 %s Message accepted for delivery", id);
+		message("250 2.0.0 %s Message accepted for delivery", id);
 	CurEnv->e_id = oldid;
 
 	/* if we just queued, poke it */
@@ -4506,6 +4518,8 @@
 	}
 	else if (sm_strcasecmp(kp, "orcpt") == 0)
 	{
+		char *p;
+
 		if (!bitset(SRV_OFFER_DSN, e->e_features))
 		{
 			usrerr("504 5.7.0 Sorry, ORCPT not supported, we do not allow DSN");
@@ -4516,16 +4530,25 @@
 			usrerr("501 5.5.2 ORCPT requires a value");
 			/* NOTREACHED */
 		}
-		if (strchr(vp, ';') == NULL || !xtextok(vp))
+		if (a->q_orcpt != NULL)
 		{
+			usrerr("501 5.5.0 Duplicate ORCPT parameter");
+			/* NOTREACHED */
+		}
+		p = strchr(vp, ';');
+		if (p == NULL)
+		{
 			usrerr("501 5.5.4 Syntax error in ORCPT parameter value");
 			/* NOTREACHED */
 		}
-		if (a->q_orcpt != NULL)
+		*p = '\0';
+		if (!isatom(vp) || !xtextok(p + 1))
 		{
-			usrerr("501 5.5.0 Duplicate ORCPT parameter");
+			*p = ';';
+			usrerr("501 5.5.4 Syntax error in ORCPT parameter value");
 			/* NOTREACHED */
 		}
+		*p = ';';
 		a->q_orcpt = sm_rpool_strdup_x(e->e_rpool, vp);
 	}
 	else
@@ -4687,7 +4710,8 @@
 		return SASL_FAIL;
 
 	macdefine(&BlankEnvelope.e_macro, A_TEMP,
-		  macid("{auth_authen}"), (char *) auth_identity);
+		  macid("{auth_authen}"),
+		  xtextify((char *) auth_identity, "=<>\")"));
 
 	return SASL_OK;
 }
@@ -4910,7 +4934,7 @@
 
 	len = strlen(topic);
 
-	while (sm_io_fgets(hf, SM_TIME_DEFAULT, buf, sizeof(buf)) != NULL)
+	while (sm_io_fgets(hf, SM_TIME_DEFAULT, buf, sizeof(buf)) >= 0)
 	{
 		if (buf[0] == '#')
 		{
--- old/usr/src/cmd/sendmail/src/stab.c	Sat Feb  6 15:36:48 2016
+++ new/usr/src/cmd/sendmail/src/stab.c	Sat Feb  6 15:36:48 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2001, 2003 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2001, 2003 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,11 +11,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: stab.c,v 8.89 2006/08/15 23:24:58 ca Exp $")
+SM_RCSID("@(#)$Id: stab.c,v 8.92 2013-11-22 20:51:56 ca Exp $")
 
 /*
 **  STAB -- manage the symbol table
@@ -67,7 +65,7 @@
 		sm_dprintf("(hfunc=%d) ", hfunc);
 
 	ps = &SymTab[hfunc];
-	if (type == ST_MACRO || type == ST_RULESET)
+	if (type == ST_MACRO || type == ST_RULESET || type == ST_NAMECANON)
 	{
 		while ((s = *ps) != NULL &&
 		       (s->s_symtype != type || strcmp(name, s->s_name)))
@@ -115,10 +113,6 @@
 		len = sizeof(s->s_class);
 		break;
 
-	  case ST_ADDRESS:
-		len = sizeof(s->s_address);
-		break;
-
 	  case ST_MAILER:
 		len = sizeof(s->s_mailer);
 		break;
--- old/usr/src/cmd/sendmail/src/stats.c	Sat Feb  6 15:36:48 2016
+++ new/usr/src/cmd/sendmail/src/stats.c	Sat Feb  6 15:36:48 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2002 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2002 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,11 +11,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: stats.c,v 8.57 2006/08/15 23:24:58 ca Exp $")
+SM_RCSID("@(#)$Id: stats.c,v 8.58 2013-11-22 20:51:56 ca Exp $")
 
 #include <sendmail/mailstats.h>
 
--- old/usr/src/cmd/sendmail/src/statusd_shm.h	Sat Feb  6 15:36:48 2016
+++ new/usr/src/cmd/sendmail/src/statusd_shm.h	Sat Feb  6 15:36:48 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1999-2000 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1999-2000 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,14 +6,12 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: statusd_shm.h,v 8.7 2000/09/17 17:30:06 gshapiro Exp $
+ *	$Id: statusd_shm.h,v 8.8 2013-11-22 20:51:57 ca Exp $
  *
  * Contributed by Exactis.com, Inc.
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
 **  The shared memory part of statusd.
 **
--- old/usr/src/cmd/sendmail/src/sysexits.c	Sat Feb  6 15:36:48 2016
+++ new/usr/src/cmd/sendmail/src/sysexits.c	Sat Feb  6 15:36:48 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,11 +11,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: sysexits.c,v 8.33.4.1 2002/09/09 02:42:37 gshapiro Exp $")
+SM_RCSID("@(#)$Id: sysexits.c,v 8.35 2013-11-22 20:51:57 ca Exp $")
 
 /*
 **  DSNTOEXITSTAT -- convert DSN-style error code to EX_ style.
--- old/usr/src/cmd/sendmail/src/sysexits.h	Sat Feb  6 15:36:48 2016
+++ new/usr/src/cmd/sendmail/src/sysexits.h	Sat Feb  6 15:36:48 2016
@@ -6,12 +6,10 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: sysexits.h,v 8.5 2000/11/26 02:13:20 ca Exp $
+ *	$Id: sysexits.h,v 8.5 2000-11-26 02:13:20 ca Exp $
  *	@(#)sysexits.h	8.1 (Berkeley) 6/2/93
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifndef _SYSEXITS_H_
 # define _SYSEXITS_H_
 
--- old/usr/src/cmd/sendmail/src/timers.h	Sat Feb  6 15:36:48 2016
+++ new/usr/src/cmd/sendmail/src/timers.h	Sat Feb  6 15:36:48 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1999-2000 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1999-2000 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,14 +6,12 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: timers.h,v 8.6 2001/04/03 01:53:18 gshapiro Exp $
+ *	$Id: timers.h,v 8.7 2013-11-22 20:51:57 ca Exp $
  *
  * Contributed by Exactis.com, Inc.
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifndef TIMERS_H
 #define TIMERS_H 1
 
--- old/usr/src/cmd/sendmail/src/tls.c	Sat Feb  6 15:36:48 2016
+++ new/usr/src/cmd/sendmail/src/tls.c	Sat Feb  6 15:36:48 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2000-2006, 2008, 2009 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2000-2006, 2008, 2009, 2011, 2013 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 2012, OmniTI Computer Consulting, Inc. All rights reserved.
  *
@@ -11,7 +11,7 @@
 
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: tls.c,v 8.114 2009/08/10 15:11:09 ca Exp $")
+SM_RCSID("@(#)$Id: tls.c,v 8.127 2013-11-27 02:51:11 gshapiro Exp $")
 
 #if STARTTLS
 #  include <openssl/err.h>
@@ -268,7 +268,7 @@
 **  INIT_TLS_LIBRARY -- Calls functions which setup TLS library for global use.
 **
 **	Parameters:
-**		none.
+**		fipsmode -- use FIPS?
 **
 **	Returns:
 **		succeeded?
@@ -275,17 +275,44 @@
 */
 
 bool
-init_tls_library()
+init_tls_library(fipsmode)
+	bool fipsmode;
 {
+	bool bv;
+
 	/* basic TLS initialization, ignore result for now */
 	SSL_library_init();
 	SSL_load_error_strings();
+	OpenSSL_add_all_algorithms();
 # if 0
 	/* this is currently a macro for SSL_library_init */
 	SSLeay_add_ssl_algorithms();
 # endif /* 0 */
 
-	return tls_rand_init(RandFile, 7);
+	bv = tls_rand_init(RandFile, 7);
+# if _FFR_FIPSMODE
+	if (bv && fipsmode)
+	{
+		if (!FIPS_mode_set(1))
+		{
+			unsigned long err;
+
+			err = ERR_get_error();
+			if (LogLevel > 0)
+				sm_syslog(LOG_ERR, NOQID,
+					"STARTTLS=init, FIPSMode=%s",
+					ERR_error_string(err, NULL));
+			return false;
+		}
+		else
+		{
+			if (LogLevel > 9)
+				sm_syslog(LOG_INFO, NOQID,
+					"STARTTLS=init, FIPSMode=ok");
+		}
+	}
+#endif /* _FFR_FIPSMODE  */
+	return bv;
 }
 /*
 **  TLS_SET_VERIFY -- request client certificate?
@@ -620,8 +647,9 @@
 	/*
 	**  valid values for dhparam are (only the first char is checked)
 	**  none	no parameters: don't use DH
-	**  512		generate 512 bit parameters (fixed)
+	**  512		use precomputed 512 bit parameters
 	**  1024	generate 1024 bit parameters
+	**  2048	generate 2048 bit parameters
 	**  /file/name	read parameters from /file/name
 	**  default is: 1024 for server, 512 for client (OK? XXX)
 	*/
@@ -634,6 +662,8 @@
 
 			if (c == '1')
 				req |= TLS_I_DH1024;
+			else if (c == '2')
+				req |= TLS_I_DH2048;
 			else if (c == '5')
 				req |= TLS_I_DH512;
 			else if (c != 'n' && c != 'N' && c != '/')
@@ -710,7 +740,7 @@
 				  "STARTTLS=%s, error: SSL_CTX_new(SSLv23_%s_method()) failed",
 				  who, who);
 		if (LogLevel > 9)
-			tlslogerr(who);
+			tlslogerr(LOG_WARNING, who);
 		return false;
 	}
 
@@ -809,7 +839,7 @@
 				  "STARTTLS=%s, error: RSA_generate_key failed",
 				  who);
 			if (LogLevel > 9)
-				tlslogerr(who);
+				tlslogerr(LOG_WARNING, who);
 		}
 		return false;
 	}
@@ -830,7 +860,7 @@
 				  "STARTTLS=%s, error: SSL_CTX_use_PrivateKey_file(%s) failed",
 				  who, keyfile);
 			if (LogLevel > 9)
-				tlslogerr(who);
+				tlslogerr(LOG_WARNING, who);
 		}
 		if (bitset(TLS_I_USE_KEY, req))
 			return false;
@@ -847,7 +877,7 @@
 				  "STARTTLS=%s, error: SSL_CTX_use_certificate_file(%s) failed",
 				  who, certfile);
 			if (LogLevel > 9)
-				tlslogerr(who);
+				tlslogerr(LOG_WARNING, who);
 		}
 		if (bitset(TLS_I_USE_CERT, req))
 			return false;
@@ -864,7 +894,7 @@
 				  "STARTTLS=%s, error: SSL_CTX_check_private_key failed(%s): %d",
 				  who, keyfile, r);
 			if (LogLevel > 9)
-				tlslogerr(who);
+				tlslogerr(LOG_WARNING, who);
 		}
 		if (bitset(TLS_I_USE_KEY, req))
 			return false;
@@ -883,7 +913,7 @@
 				  "STARTTLS=%s, error: SSL_CTX_use_PrivateKey_file(%s) failed",
 				  who, kf2);
 			if (LogLevel > 9)
-				tlslogerr(who);
+				tlslogerr(LOG_WARNING, who);
 		}
 	}
 
@@ -897,7 +927,7 @@
 				  "STARTTLS=%s, error: SSL_CTX_use_certificate_file(%s) failed",
 				  who, cf2);
 			if (LogLevel > 9)
-				tlslogerr(who);
+				tlslogerr(LOG_WARNING, who);
 		}
 	}
 
@@ -912,7 +942,7 @@
 				  "STARTTLS=%s, error: SSL_CTX_check_private_key 2 failed: %d",
 				  who, r);
 			if (LogLevel > 9)
-				tlslogerr(who);
+				tlslogerr(LOG_WARNING, who);
 		}
 	}
 # endif /* _FFR_TLS_1 */
@@ -945,6 +975,9 @@
 	/* Diffie-Hellman initialization */
 	if (bitset(TLS_I_TRY_DH, req))
 	{
+#if _FFR_TLS_EC
+		EC_KEY *ecdh;
+#endif /* _FFR_TLS_EC */
 		if (bitset(TLS_S_DHPAR_OK, status))
 		{
 			BIO *bio;
@@ -963,7 +996,7 @@
 						  who, dhparam,
 						  ERR_error_string(err, NULL));
 					if (LogLevel > 9)
-						tlslogerr(who);
+						tlslogerr(LOG_WARNING, who);
 				}
 			}
 			else
@@ -974,16 +1007,21 @@
 						  "STARTTLS=%s, error: BIO_new_file(%s) failed",
 						  who, dhparam);
 					if (LogLevel > 9)
-						tlslogerr(who);
+						tlslogerr(LOG_WARNING, who);
 				}
 			}
 		}
-		if (dh == NULL && bitset(TLS_I_DH1024, req))
+		if (dh == NULL && bitset(TLS_I_DH1024|TLS_I_DH2048, req))
 		{
+			int bits;
 			DSA *dsa;
 
-			/* this takes a while! (7-130s on a 450MHz AMD K6-2) */
-			dsa = DSA_generate_parameters(1024, NULL, 0, NULL,
+			bits = bitset(TLS_I_DH2048, req) ? 2048 : 1024;
+			if (tTd(96, 2))
+				sm_dprintf("inittls: Generating %d bit DH parameters\n", bits);
+
+			/* this takes a while! */
+			dsa = DSA_generate_parameters(bits, NULL, 0, NULL,
 						      NULL, 0, NULL);
 			dh = DSA_dup_DH(dsa);
 			DSA_free(dsa);
@@ -990,7 +1028,11 @@
 		}
 		else
 		if (dh == NULL && bitset(TLS_I_DH512, req))
+		{
+			if (tTd(96, 2))
+				sm_dprintf("inittls: Using precomputed 512 bit DH parameters\n");
 			dh = get_dh512();
+		}
 
 		if (dh == NULL)
 		{
@@ -1009,10 +1051,10 @@
 		}
 		else
 		{
-			SSL_CTX_set_tmp_dh(*ctx, dh);
-
 			/* important to avoid small subgroup attacks */
 			SSL_CTX_set_options(*ctx, SSL_OP_SINGLE_DH_USE);
+
+			SSL_CTX_set_tmp_dh(*ctx, dh);
 			if (LogLevel > 13)
 				sm_syslog(LOG_INFO, NOQID,
 					  "STARTTLS=%s, Diffie-Hellman init, key=%d bit (%c)",
@@ -1019,6 +1061,17 @@
 					  who, 8 * DH_size(dh), *dhparam);
 			DH_free(dh);
 		}
+
+#if _FFR_TLS_EC
+		ecdh = EC_KEY_new_by_curve_name(NID_X9_62_prime256v1);
+		if (ecdh != NULL)
+		{
+			SSL_CTX_set_options(*ctx, SSL_OP_SINGLE_ECDH_USE);
+			SSL_CTX_set_tmp_ecdh(*ctx, ecdh);
+			EC_KEY_free(ecdh);
+		}
+#endif /* _FFR_TLS_EC */
+
 	}
 # endif /* !NO_DH */
 
@@ -1090,7 +1143,7 @@
 					  "STARTTLS=%s, error: load verify locs %s, %s failed: %d",
 					  who, cacertpath, cacertfile, r);
 				if (LogLevel > 9)
-					tlslogerr(who);
+					tlslogerr(LOG_WARNING, who);
 			}
 			if (bitset(TLS_I_VRFY_LOC, req))
 				return false;
@@ -1114,7 +1167,7 @@
 					  who, CipherList);
 
 				if (LogLevel > 9)
-					tlslogerr(who);
+					tlslogerr(LOG_WARNING, who);
 			}
 			/* failure if setting to this list is required? */
 		}
@@ -1214,12 +1267,14 @@
 		macdefine(mac, A_TEMP, macid("{cert_issuer}"),
 			 xtextify(buf, "<>\")"));
 
+# define LL_BADCERT	8
+
 #define CHECK_X509_NAME(which)	\
 	do {	\
 		if (r == -1)	\
 		{		\
 			sm_strlcpy(buf, "BadCertificateUnknown", sizeof(buf)); \
-			if (LogLevel > 7)	\
+			if (LogLevel > LL_BADCERT)	\
 				sm_syslog(LOG_INFO, NOQID,	\
 					"STARTTLS=%s, relay=%.100s, field=%s, status=failed to extract CN",	\
 					who,	\
@@ -1376,7 +1431,7 @@
 				sm_syslog(LOG_WARNING, NOQID,
 					  "STARTTLS=%s, SSL_shutdown failed: %d",
 					  side, r);
-				tlslogerr(side);
+				tlslogerr(LOG_WARNING, side);
 			}
 			ret = EX_SOFTWARE;
 		}
@@ -1425,7 +1480,7 @@
 				sm_syslog(LOG_WARNING, NOQID,
 					  "STARTTLS=%s, SSL_shutdown not done",
 					  side);
-				tlslogerr(side);
+				tlslogerr(LOG_WARNING, side);
 			}
 			ret = EX_SOFTWARE;
 		}
@@ -1658,6 +1713,7 @@
 **  TLSLOGERR -- log the errors from the TLS error stack
 **
 **	Parameters:
+**		level -- syslog level
 **		who -- server/client (for logging).
 **
 **	Returns:
@@ -1665,7 +1721,8 @@
 */
 
 void
-tlslogerr(who)
+tlslogerr(level, who)
+	int level;
 	const char *who;
 {
 	unsigned long l;
@@ -1679,7 +1736,7 @@
 	while ((l = ERR_get_error_line_data(CP &file, &line, CP &data, &flags))
 		!= 0)
 	{
-		sm_syslog(LOG_WARNING, NOQID,
+		sm_syslog(level, NOQID,
 			  "STARTTLS=%s: %lu:%s:%s:%d:%s", who, es,
 			  ERR_error_string(l, buf),
 			  file, line,
--- old/usr/src/cmd/sendmail/src/trace.c	Sat Feb  6 15:36:48 2016
+++ new/usr/src/cmd/sendmail/src/trace.c	Sat Feb  6 15:36:48 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2001 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2001 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,13 +11,11 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 #include <sm/debug.h>
 #include <sm/string.h>
 
-SM_RCSID("@(#)$Id: trace.c,v 8.37.4.1 2002/12/05 17:28:05 ca Exp $")
+SM_RCSID("@(#)$Id: trace.c,v 8.39 2013-11-22 20:51:57 ca Exp $")
 
 static char	*tTnewflag __P((char *));
 static char	*tToldflag __P((char *));
--- old/usr/src/cmd/sendmail/src/udb.c	Sat Feb  6 15:36:49 2016
+++ new/usr/src/cmd/sendmail/src/udb.c	Sat Feb  6 15:36:49 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2003, 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2003, 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,15 +11,13 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 #include "map.h"
 
 #if USERDB
-SM_RCSID("@(#)$Id: udb.c,v 8.164 2006/12/19 19:49:51 ca Exp $ (with USERDB)")
+SM_RCSID("@(#)$Id: udb.c,v 8.166 2013-11-22 20:51:57 ca Exp $ (with USERDB)")
 #else /* USERDB */
-SM_RCSID("@(#)$Id: udb.c,v 8.164 2006/12/19 19:49:51 ca Exp $ (without USERDB)")
+SM_RCSID("@(#)$Id: udb.c,v 8.166 2013-11-22 20:51:57 ca Exp $ (without USERDB)")
 #endif /* USERDB */
 
 #if USERDB
@@ -1221,7 +1219,7 @@
 #  endif /* DB_VERSION_MAJOR < 2 */
 		}
 		if (tTd(28, 1))
-			sm_dprintf("_udbx_init: db->close(%s)\n",
+			sm_dprintf("_udbx_close: db->close(%s)\n",
 				up->udb_dbname);
 # endif /* NEWDB */
 	}
--- old/usr/src/cmd/sendmail/src/usersmtp.c	Sat Feb  6 15:36:49 2016
+++ new/usr/src/cmd/sendmail/src/usersmtp.c	Sat Feb  6 15:36:49 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2006, 2008, 2009 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2006, 2008-2010 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -13,7 +13,7 @@
 
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: usersmtp.c,v 8.473 2009/06/17 17:26:51 ca Exp $")
+SM_RCSID("@(#)$Id: usersmtp.c,v 8.488 2013-11-22 20:51:57 ca Exp $")
 
 #include <sysexits.h>
 
@@ -33,7 +33,6 @@
 **	This protocol is described in RFC821.
 */
 
-#define REPLYCLASS(r)	(((r) / 10) % 10)	/* second digit of reply code */
 #define SMTPCLOSING	421			/* "Service Shutting Down" */
 
 #define ENHSCN(e, d)	((e) == NULL ? (d) : (e))
@@ -136,8 +135,7 @@
 	SmtpPhase = mci->mci_phase = "client greeting";
 	sm_setproctitle(true, e, "%s %s: %s",
 			qid_printname(e), CurHostName, mci->mci_phase);
-	r = reply(m, mci, e, TimeOuts.to_initial, esmtp_check, NULL,
-		XS_DEFAULT);
+	r = reply(m, mci, e, TimeOuts.to_initial, esmtp_check, NULL, XS_GREET);
 	if (r < 0)
 		goto tempfail1;
 	if (REPLYTYPE(r) == 4)
@@ -183,7 +181,7 @@
 	r = reply(m, mci, e,
 		  bitnset(M_LMTP, m->m_flags) ? TimeOuts.to_lhlo
 					      : TimeOuts.to_helo,
-		  helo_options, NULL, XS_DEFAULT);
+		  helo_options, NULL, XS_EHLO);
 	if (r < 0)
 		goto tempfail1;
 	else if (REPLYTYPE(r) == 5)
@@ -336,7 +334,15 @@
 	l1 = strlen(s1);
 	l2 = strlen(s2);
 	rl = l1 + l2;
-	res = (char *) sm_rpool_malloc(rpool, rl + 2);
+	if (rl <= 0)
+	{
+		sm_syslog(LOG_WARNING, NOQID,
+			  "str_union: stringlen1=%d, stringlen2=%d, sum=%d, status=overflow",
+			  l1, l2, rl);
+		res = NULL;
+	}
+	else
+		res = (char *) sm_rpool_malloc(rpool, rl + 2);
 	if (res == NULL)
 	{
 		if (l1 > l2)
@@ -409,9 +415,7 @@
 
 	if (firstline)
 	{
-#if SASL
-		mci->mci_saslcap = NULL;
-#endif /* SASL */
+		mci_clr_extensions(mci);
 #if _FFR_IGNORE_EXT_ON_HELO
 		logged = false;
 #endif /* _FFR_IGNORE_EXT_ON_HELO */
@@ -472,7 +476,8 @@
 #if SASL
 	else if (sm_strcasecmp(line, "auth") == 0)
 	{
-		if (p != NULL && *p != '\0')
+		if (p != NULL && *p != '\0' &&
+		    !bitset(MCIF_AUTH2, mci->mci_flags))
 		{
 			if (mci->mci_saslcap != NULL)
 			{
@@ -484,7 +489,7 @@
 
 				mci->mci_saslcap = str_union(mci->mci_saslcap,
 							     p, mci->mci_rpool);
-				mci->mci_flags |= MCIF_AUTH;
+				mci->mci_flags |= MCIF_AUTH2;
 			}
 			else
 			{
@@ -501,6 +506,9 @@
 				}
 			}
 		}
+		if (tTd(95, 5))
+			sm_syslog(LOG_DEBUG, NOQID, "AUTH flags=%lx, mechs=%s",
+				mci->mci_flags, mci->mci_saslcap);
 	}
 #endif /* SASL */
 }
@@ -516,15 +524,15 @@
 
 static sasl_callback_t callbacks[] =
 {
-	{	SASL_CB_GETREALM,	&saslgetrealm,	NULL	},
+	{	SASL_CB_GETREALM,	(sasl_callback_ft)&saslgetrealm,	NULL	},
 #define CB_GETREALM_IDX	0
-	{	SASL_CB_PASS,		&getsecret,	NULL	},
+	{	SASL_CB_PASS,		(sasl_callback_ft)&getsecret,	NULL	},
 #define CB_PASS_IDX	1
-	{	SASL_CB_USER,		&getsimple,	NULL	},
+	{	SASL_CB_USER,		(sasl_callback_ft)&getsimple,	NULL	},
 #define CB_USER_IDX	2
-	{	SASL_CB_AUTHNAME,	&getsimple,	NULL	},
+	{	SASL_CB_AUTHNAME,	(sasl_callback_ft)&getsimple,	NULL	},
 #define CB_AUTHNAME_IDX	3
-	{	SASL_CB_VERIFYFILE,	&safesaslfile,	NULL	},
+	{	SASL_CB_VERIFYFILE,	(sasl_callback_ft)&safesaslfile,	NULL	},
 #define CB_SAFESASL_IDX	4
 	{	SASL_CB_LIST_END,	NULL,		NULL	}
 };
@@ -793,7 +801,7 @@
 
 	lc = 0;
 	while (lc <= SASL_MECHLIST &&
-		sm_io_fgets(f, SM_TIME_DEFAULT, buf, sizeof(buf)) != NULL)
+		sm_io_fgets(f, SM_TIME_DEFAULT, buf, sizeof(buf)) >= 0)
 	{
 		if (buf[0] != '#')
 		{
@@ -1606,13 +1614,11 @@
 	(void) memset(&ssp, '\0', sizeof(ssp));
 
 	/* XXX should these be options settable via .cf ? */
-	{
-		ssp.max_ssf = MaxSLBits;
-		ssp.maxbufsize = MAXOUTLEN;
+	ssp.max_ssf = MaxSLBits;
+	ssp.maxbufsize = MAXOUTLEN;
 #  if 0
-		ssp.security_flags = SASL_SEC_NOPLAINTEXT;
+	ssp.security_flags = SASL_SEC_NOPLAINTEXT;
 #  endif /* 0 */
-	}
 	saslresult = sasl_setprop(mci->mci_conn, SASL_SEC_PROPS, &ssp);
 	if (saslresult != SASL_OK)
 		return EX_TEMPFAIL;
@@ -2175,7 +2181,7 @@
 	SmtpPhase = mci->mci_phase = "client MAIL";
 	sm_setproctitle(true, e, "%s %s: %s", qid_printname(e),
 			CurHostName, mci->mci_phase);
-	r = reply(m, mci, e, TimeOuts.to_mail, NULL, &enhsc, XS_DEFAULT);
+	r = reply(m, mci, e, TimeOuts.to_mail, NULL, &enhsc, XS_MAIL);
 	if (r < 0)
 	{
 		/* communications failure */
@@ -2427,7 +2433,7 @@
 	}
 
 	enhsc = NULL;
-	r = reply(m, mci, e, TimeOuts.to_rcpt, NULL, &enhsc, XS_DEFAULT);
+	r = reply(m, mci, e, TimeOuts.to_rcpt, NULL, &enhsc, XS_RCPT);
 	save_errno = errno;
 	to->q_rstatus = sm_rpool_strdup_x(e->e_rpool, SmtpReplyBuffer);
 	to->q_status = ENHSCN_RPOOL(enhsc, smtptodsn(r), e->e_rpool);
@@ -2588,7 +2594,7 @@
 	mci->mci_state = MCIS_DATA;
 	sm_setproctitle(true, e, "%s %s: %s",
 			qid_printname(e), CurHostName, mci->mci_phase);
-	r = reply(m, mci, e, TimeOuts.to_datainit, NULL, &enhsc, XS_DEFAULT);
+	r = reply(m, mci, e, TimeOuts.to_datainit, NULL, &enhsc, XS_DATA);
 	if (r < 0 || REPLYTYPE(r) == 4)
 	{
 		if (r >= 0)
@@ -2722,7 +2728,7 @@
 			CurHostName, mci->mci_phase);
 	if (bitnset(M_LMTP, m->m_flags))
 		return EX_OK;
-	r = reply(m, mci, e, TimeOuts.to_datafinal, NULL, &enhsc, XS_DEFAULT);
+	r = reply(m, mci, e, TimeOuts.to_datafinal, NULL, &enhsc, XS_EOM);
 	if (r < 0)
 		return EX_TEMPFAIL;
 	if (mci->mci_state == MCIS_DATA)
@@ -2807,7 +2813,7 @@
 	enhsc = NULL;
 
 	/* check for the results of the transaction */
-	r = reply(m, mci, e, TimeOuts.to_datafinal, NULL, &enhsc, XS_DEFAULT);
+	r = reply(m, mci, e, TimeOuts.to_datafinal, NULL, &enhsc, XS_DATA2);
 	if (r < 0)
 		return EX_TEMPFAIL;
 	xstat = EX_NOTSTICKY;
@@ -2893,8 +2899,7 @@
 		SmtpPhase = "client QUIT";
 		mci->mci_state = MCIS_QUITING;
 		smtpmessage("QUIT", m, mci);
-		(void) reply(m, mci, e, TimeOuts.to_quit, NULL, NULL,
-				XS_DEFAULT);
+		(void) reply(m, mci, e, TimeOuts.to_quit, NULL, NULL, XS_QUIT);
 		SuprErrs = oldSuprErrs;
 		if (mci->mci_state == MCIS_CLOSED)
 			goto end;
@@ -3233,15 +3238,18 @@
 		if (pfunc != NULL)
 			(*pfunc)(bufp, firstline, m, mci, e);
 
-		firstline = false;
-
 		/* decode the reply code */
 		r = atoi(bufp);
 
 		/* extra semantics: 0xx codes are "informational" */
 		if (r < 100)
+		{
+			firstline = false;
 			continue;
+		}
 
+		firstline = false;
+
 		/* if no continuation lines, return this line */
 		if (bufp[3] != '-')
 			break;
--- old/usr/src/cmd/sendmail/src/util.c	Sat Feb  6 15:36:49 2016
+++ new/usr/src/cmd/sendmail/src/util.c	Sat Feb  6 15:36:49 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2007, 2009 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2007, 2009 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -13,7 +13,7 @@
 
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: util.c,v 8.416 2009/12/18 17:05:26 ca Exp $")
+SM_RCSID("@(#)$Id: util.c,v 8.427 2013-11-22 20:51:57 ca Exp $")
 
 #include <sm/sendmail.h>
 #include <sysexits.h>
@@ -1285,8 +1285,7 @@
 	char *during;
 {
 	register char *p;
-	int save_errno;
-	int io_timeout;
+	int save_errno, io_timeout, l;
 
 	SM_REQUIRE(siz > 0);
 	SM_REQUIRE(buf != NULL);
@@ -1299,7 +1298,7 @@
 	}
 
 	/* try to read */
-	p = NULL;
+	l = -1;
 	errno = 0;
 
 	/* convert the timeout to sm_io notation */
@@ -1307,8 +1306,8 @@
 	while (!sm_io_eof(fp) && !sm_io_error(fp))
 	{
 		errno = 0;
-		p = sm_io_fgets(fp, io_timeout, buf, siz);
-		if (p == NULL && errno == EAGAIN)
+		l = sm_io_fgets(fp, io_timeout, buf, siz);
+		if (l < 0 && errno == EAGAIN)
 		{
 			/* The sm_io_fgets() call timedout */
 			if (LogLevel > 1)
@@ -1328,7 +1327,7 @@
 			errno = ETIMEDOUT;
 			return NULL;
 		}
-		if (p != NULL || errno != EINTR)
+		if (l >= 0 || errno != EINTR)
 			break;
 		(void) sm_io_clearerr(fp);
 	}
@@ -1336,7 +1335,7 @@
 
 	/* clean up the books and exit */
 	LineNumber++;
-	if (p == NULL)
+	if (l < 0)
 	{
 		buf[0] = '\0';
 		if (TrafficLogFile != NULL)
@@ -2638,7 +2637,13 @@
 		mark_work_group_restart(ProcListVec[i].proc_other, st);
 	}
 	else if (type == PROC_QUEUE)
+	{
 		CurRunners -= ProcListVec[i].proc_count;
+
+		/* CHK_CUR_RUNNERS() can't be used here: uses syslog() */
+		if (CurRunners < 0)
+			CurRunners = 0;
+	}
 }
 
 /*
@@ -2702,6 +2707,14 @@
 					  (int) ProcListVec[i].proc_pid);
 			ProcListVec[i].proc_pid = NO_PID;
 			SM_FREE_CLR(ProcListVec[i].proc_task);
+
+			if (ProcListVec[i].proc_type == PROC_QUEUE)
+			{
+				CurRunners -= ProcListVec[i].proc_count;
+				CHK_CUR_RUNNERS("proc_list_probe", i,
+						ProcListVec[i].proc_count);
+			}
+
 			CurChildren--;
 		}
 		else
@@ -2852,3 +2865,4 @@
 	}
 	return n;
 }
+
--- old/usr/src/cmd/sendmail/src/version.c	Sat Feb  6 15:36:49 2016
+++ new/usr/src/cmd/sendmail/src/version.c	Sat Feb  6 15:36:49 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2009 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2014 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -13,6 +13,6 @@
 
 #include <sm/gen.h>
 
-SM_RCSID("@(#)$Id: version.c,v 8.218 2009/12/23 04:43:09 ca Exp $")
+SM_RCSID("@(#)$Id: version.c,v 8.249 2013-11-27 00:38:50 ca Exp $")
 
-char	Version[] = "8.14.4+Sun";
+char	Version[] = "8.14.9+Sun";
